#include <graphx.h>
#include <math.h>
#include <stdint.h>
#include <tice.h>

#define PI 3.14159

uint8_t background_colour = 0x1d; // also 0x1c, 0x14, 0x15, 0x1e are good colours
uint8_t foreground_colour = 0xff;

int offset_x = 120, offset_y = 70; // not sure if i'll actually need this

int center_x = 160, center_y = 110;
long ticks      = 0;
float angles[5] = {0, PI / 15, PI / 7.5, PI / 5, PI / 3.75};

void get_angles() {
    for (int c = 0; c < 5; c++) {
        angles[c] += fabs(cos(ticks * 32.0 * PI / 6)) * 0.25;
    }
}

int main() {
    gfx_Begin();
    gfx_SetTextFGColor(foreground_colour);
    gfx_SetTextBGColor(background_colour);
    gfx_SetTextTransparentColor(5);

    gfx_SetTextConfig(gfx_text_noclip);
    gfx_SetMonospaceFont(8);
    while (!os_GetCSC() || ticks < 320) {
        gfx_SetDrawBuffer();
        gfx_FillScreen(background_colour);
        gfx_PrintStringXY("Updating Windows...", 80, 160);
        gfx_PrintStringXY("Don't turn off your calculator", 40, 170);
        gfx_SetColor(foreground_colour);

        for (int i = 0; i < 5; i++) {
            int x = center_x + (int) (cos(angles[i]) * 40);
            int y = center_y + (int) (sin(angles[i]) * 40);
            gfx_FillCircle(x, y, 3);
        }

        gfx_SwapDraw();

        ticks++;
        get_angles();
    }
    gfx_End();
}